﻿class org.moock.tools.EventProxy {
  private var receiverObj:Object;
  private var funcRef:Function;
 
  /** 
   * receiverObj  The object on which funcRef will be called.
   * funcRef      A reference to the function to call in response to the event
   */
  function EventProxy(receiverObj:Object, funcRef:Function) {
    this.receiverObj  = receiverObj;
    this.funcRef = funcRef;
  }
 
  /**
   * Invoked before the registered event is broadcast by the component.
   * Proxies the event call out to the receiverObj object's method.
   */
  private function handleEvent(eventObj:Object):Void {
    // If no function name has been defined...
    if (funcRef == undefined) {
      // ...pass the call to the event name method
      receiverObj[eventObj.type](eventObj);
    } else {
      // ...otherwise, pass the call to the specified method
      funcRef.call(receiverObj, eventObj);
    }
  }
}
