﻿class Rectangle extends Shape implements Serializable {
  private var width:Number = 0;
  private var height:Number = 0;
  private var serializer:Serializer;

  public function Rectangle (t:MovieClip, d:Number) {
    super(t, d);
 
    serializer = new Serializer();
    serializer.setRecordSeparator("|");
    serializer.setSerializationProps(["height", "width"]);
    serializer.setSerializationObj(this);
  }

  public function setSize (w:Number, h:Number):Void {
    width = w;
    height = h;
  }

  public function getArea () {
    return width * height;
  }

  public function draw ():Void {
    var container_mc:MovieClip = target.createEmptyMovieClip("rect" + depth, depth);
    container_mc.clear();
    container_mc.lineStyle(1, 0x000000);
    container_mc.moveTo(0, 0);
    container_mc.beginFill(0xFFFFFF, 100);
    container_mc.lineTo(width, 0);
    container_mc.lineTo(width, height);
    container_mc.lineTo(0, height);
    container_mc.lineTo(0, 0);
    container_mc.endFill();
  }

  public function serialize ():String {
    return serializer.serialize();
  }
}

